#!/usr/bin/microperl

# Create a shell script using wget for an Asus or similar to
# get XML dat files from the Radio Times web site
# Nigel Whitfield, 2005

# 0.1 original version
# 0.2 added user agent header, and wait between channels

# RadioTimes.com makes the data available for personal use

# start by finding out if we have wget

$wget = `which wget` ;

($wget =~ /\/wget/ ) || die("You don't appear to have wget installed\n") ;

print "Found wget in $wget" ;
chop $wget ;

# now read  channelmap.ini to find out which we need
open( MAP, 'channelmap.ini' ) || die("Unable to open channelmap.ini\n") ;

open( SH, '> getdat.sh' ) || die("Unable to open script file for writing\n") ;

print SH "#!/bin/sh
# getdat.sh
# Nigel Whitfield, 2005
# Script to fetch Radio Times data, for personal use on the Topfield PVR

# If you change channelmap.ini, rebuild this file by running
# genwget.pl\ncd channels\n\n" ;

while(<MAP>) {

	next if /^#/ ;

	($channel, $rtid) = split(/\s+/) ;

	if ( $rtid eq '' ) {
		print "Skipping $channel - no Radio Times id\n" ;
	} else {

		print SH "# $channel:\n" ;

		print SH "$wget -q --header 'User-Agent: NW RTscripts; nigel\@nigelwhitfield.com' http://xmltv.radiotimes.com/xmltv/$rtid.dat\n" ;
		print SH "mv $rtid.dat $channel.dat\n" ;
		print SH "sleep 2\n" ;
	}
}

close MAP ;
close SH ;

chmod 0755, 'getdat.sh' ;

