#!/usr/bin/perl -s

use LWP::Simple ;

# get XML dat files from the Radio Times web site
# Nigel Whitfield, 2005

# 0.1 original version
# 0.2 added info in query string to identify software, pause between channels

# RadioTimes.com makes the data available for personal use

# if a single channel is specified on the command line
# you can fetch just that channel, eg getdat.pl bbc4
#
# start by reading channelmap.ini to find out which we need

open( MAP, 'channelmap.ini' ) || die("Unable to open channelmap.ini\n") ;

while(<MAP>) {

	next if /^#/ ;

	($channel, $rtid,$opts) = split(/\s+/) ;

	if ( $ARGV[0] ne '' ) {
		next if $channel ne $ARGV[0] ;
	}

	if ( $rtid eq '' ) {
		print "Skipping $channel - no Radio Times id\n" ;
	} else {
		$verbose && print "Loading $channel from http://xmltv.radiotimes.com/xmltv/$rtid.dat\n" ;

		if ( $epgdata = get("http://xmltv.radiotimes.com/xmltv/$rtid.dat?RTscripts+nigel%40nigelwhitfield.com")) { 
			open(RTFEED, "> channels/$channel.dat\n") || die("Can't open output file for $channel\n") ;
			print RTFEED $epgdata ;
			close RTFEED ;
			sleep(2) ;
		} else {
			print("Error fetching data for $channel\n") ;
		}

	}
}

close MAP ;

